
/*                                                                           *
 * Revision history:                                                         *
 *                                                                           *
 * $Log: main.h,v $
 * Revision 1.2  2003/09/17 15:03:06  tos
 * Mod's:
 *   - introduced new menu option ('J'): access (w/r) CC1020 register.
 *   - update EEPROM variable+table upon register write access ('J').
 *   - introduced new configuration option ('I'): preamble length.
 *   - moved TX buffer initialisation after configuration.
 *   - corrected inconsistent number conversion funtion.
 *
 * Revision 1.1  2003/07/31 13:17:25  tos
 * Initial version in CVS.
 *
 *
 *                                                                           *
 ****************************************************************************/


enum StateType {IDLE_STATE,RX_STATE,TX_STATE};

extern volatile struct
{
  unsigned char PreambleFound:1;
  unsigned char UI1Found:1;
  unsigned char LastPreambleBit:1;
  unsigned char FreezeAGCLevel:1;
  unsigned char ReleaseAGCLevel:1;
  unsigned char LastDataBit:1;
};


extern volatile enum StateType State;
extern volatile enum StateType NextState;

extern volatile __bank1 char TXBuffer[TX_BUFFER_SIZE]; 
extern volatile __bank2 char RXBuffer[RX_BUFFER_SIZE];

extern union {
  char ShiftReg;
  struct {
    unsigned char ShiftRegLSB :1;
    unsigned char :1;
    unsigned char :1;
    unsigned char :1;
    unsigned char :1;
    unsigned char :1;
    unsigned char :1;
    unsigned char ShiftRegMSB :1;
  };
};
    
extern char BitCounter;

extern volatile char TXBufferIndex;            
extern char RXBufferReadIndex;
extern volatile char RXBufferWriteIndex;

extern char BytesToSend;
extern char BytesToReceive;

extern char PreambleCount;
extern char PreambleError;

extern char ByteCounter;

extern char Button1Char;
extern char Button2Char;

extern char RXANALOG;
extern char TXANALOG;

extern char PA_POWER;

extern char PreambleLength;
