


 //
 // EEP.C: Created 2003 05 13
 //    EEPROM procedures
 //
 // (C) Micrel Norway AS
 //     Proprietary firmware of Micrel Norway AS
 //
 


 // Note: The intention of the firmware listed below is to help users 
 //       get hands-on experience with Micrel Norway's products.
 
 //       No guarantee is implied as to the suitableness of the firmware 
 //       in a given application.
 
 //       For further information, please contact post@micrel.no


 #define C_FILE   // Tested in "p18xxxx.h" (to include correct file for C/ASM - programs)
 #define EEP_FILE // The file "eep.h" tests if this definition is made or not
 
 

//*************************************************
//
// Include files
//
//************************************************* 
 #include "p18def.h"  // Define PIC used
 #include "p18xxxx.h" // Standard Microchip file for the selected PIC
 #include "c_subst.h" //
 
 #include "eep.h"     //


 
//*************************************************
//
// Code starts here
//
//************************************************* 
 #pragma code
 #pragma udata
      

// Read and return contents in "ee_address"
uint8
EEP_Read_EEprom( uint8 ee_address)
{
   static uint8 helpreg;

   EEADR  = ee_address;

   EECON1 = 0;
   EECON1bits.RD = 1;
   helpreg = EEDATA;  // Read as soon as posible after setting RD
   return( helpreg);
}



void
EEP_Write_EEprom( uint8 ee_address, uint8 ee_data)
{
   EEADR  = ee_address;
   EEDATA = ee_data;
   EECON1 = 0;
   while( INTCONbits.GIE)
   {
      INTCONbits.GIE = 0;
   }  
   EECON1bits.WREN = 1;
   EECON2 = 0x55;
   EECON2 = 0xAA;
   EECON1bits.WR  = 1;
   INTCONbits.GIE = 1;
   while( EECON1bits.WR)
   {
   }
   EECON1bits.WREN = 0;
   
}



// Write and read back to confirm the read value
// Future feature: Return a value indicating ok/not ok 
// (if writing unsuccessfully x times)
// Note: Do not write if location already holds the value
void
EEP_Write_And_Confirm( uint8 ee_address, uint8 ee_data)
{
   while( EEP_Read_EEprom( ee_address) != ee_data)
   {
      EEP_Write_EEprom( ee_address, ee_data);
   }
}


/*
void
EEP_Data_Refresh( void)
{
   static uint8 helpreg;
   
   EEADR  = 0;   
   EECON1 = 0;
   while( INTCONbits.GIE)
   {
      INTCONbits.GIE = 0;
   }
   EECON1bits.WREN = 1;
   
   do
   {
      EECON1bits.RD = 1;
      helpreg = EEDATA;
      Nop();
      EEDATA = helpreg;
      EECON2 = 0x55;
      EECON2 = 0xAA;
      EECON1bits.WR = 1;

      while( EECON1bits.WR)
      {
      }
      EEADR++;
   }
   while( EEADR);
   
   INTCONbits.GIE  = 1;
   EECON1bits.WREN = 1;
}
*/
