


 //
 // GEN.C: Created 2003 01 21
 //    General purpose functions and procedures
 //
 // (C) Micrel Norway AS
 //     Proprietary firmware of Micrel Norway AS
 //
 


 // Note: The intention of the firmware listed below is to help users 
 //       get hands-on experience with Micrel Norway's products.
 
 //       No guarantee is implied as to the suitableness of the firmware 
 //       in a given application.
 
 //       For further information, please contact post@micrel.no 


 #define C_FILE   // Tested in "p18xxxx.h" (to include correct file for C/ASM - programs)
 #define GEN_FILE // Tested in gen.h



//*************************************************
//
// Include files
//
//************************************************* 
 #include "p18def.h"  // Define PIC used
 #include "p18xxxx.h" // Standard Microchip file for the selected PIC
 #include "c_subst.h" //

 #include "io_xxx.h"  //
 #include "gen.h"     // Prototypes, variables and constants



//*************************************************
//
// Code starts here 
//
//*************************************************
 #pragma code
 #pragma udata

/*
void 
GEN_Reset_Tmr1_Ccpx( void)
{
   INTCONbits.INT0IE  = 0; // Disable INT0 interrupt
   INTCONbits.INT0IF  = 0; // Clear INT0 int flag


   PIE1bits.TMR1IE = 0;
   PIE1bits.CCP1IE = 0;
   PIE2bits.CCP2IE = 0;

   T1CON   = 0;
   CCP1CON = 0;
   CCP2CON = 0;

   TMR1H = 0;
   TMR1L = 0;
   PIR1bits.TMR1IF = 0;

   CCPR1H = 0;
   CCPR1L = 0;
   PIR1bits.CCP1IF = 0;

   CCPR2H = 0;
   CCPR2L = 0;
   PIR2bits.CCP2IF = 0;
}
*/

/*
void
GEN_Reset_Tmr2( void)
{
   PIE1bits.TMR2IE = 0;
   T2CON = 0x00;
   TMR2  = 0x00;
   PR2   = 0xFF;
   PIR1bits.TMR2IF = 0;
}
*/


void
GEN_Enable_Int( void)
{
   RCONbits.IPEN   = 1;
   INTCONbits.GIEH = 1;
   INTCONbits.GIEL = 1;
}



void
GEN_Init_Ports( void)
{

   ADCON1 = IO_ADCON1INI; // Select AD or digital inputs

   LATA  = IO_LATAINI;
   TRISA = IO_TRISAINI;

   LATB  = IO_LATBINI;
   TRISB = IO_TRISBINI;

   LATC  = IO_LATCINI;
   TRISC = IO_TRISCINI;

   LATD  = IO_LATDINI;
   TRISD = IO_TRISDINI;

   LATE  = IO_LATEINI;
   TRISE = IO_TRISEINI;
   
}



void
GEN_Clear_Access_Ram( void)
{
   uint8 i,
        *i_p;

   i_p = 0;
   
   for ( i = 0 ; i <= (uint8)127 ; i++)
   {
      *i_p = 0;
      i_p++;
   }
}



// For the MS nibble, find the ascii-char (0-9, A-F)
uint8
GEN_Bin_Ascii_High( uint8 Binary_byte)
{
   uint8 temp_char;

   temp_char = Binary_byte >> 4;
   temp_char = temp_char bit_and 0xF;
   
   temp_char = temp_char + 48;
   if( temp_char >= (uint8)58) 
      temp_char = temp_char + 7;

   return( temp_char);
}


// For the LS nibble, find the ascii-char (0-9, A-F)
uint8
GEN_Bin_Ascii_Low( uint8 Binary_byte)
{
   uint8 temp_char;

   temp_char = Binary_byte;
   temp_char = temp_char bit_and 0xF;
   
   temp_char = temp_char + 48;
   if( temp_char >= (uint8)58) 
      temp_char = temp_char + 7;

   return( temp_char);
}



// Translate from ascii to hex
uint8
GEN_Ascii_Bin( uint8 Ascii_byte)
{
	uint8 temp_char;

	if( Ascii_byte >= '0' && Ascii_byte <= '9')
	{
		temp_char = (Ascii_byte - '0');
	}
	else
	{
		temp_char = (Ascii_byte - 'A' + 10);
	}

	temp_char &= 0x0F;

	return( temp_char);
}




uint8
GEN_Byte_Ascii_Bin( uint8 ms_nibble, uint8 ls_nibble)
{
   uint8 help_reg;

   help_reg = GEN_Ascii_Bin( ms_nibble);
   help_reg <<= 4;
   help_reg &= 0xF0;

   help_reg += GEN_Ascii_Bin( ls_nibble);

   return( help_reg);
}
