


 //
 // IO_EV506.H: Created 2004 05 25
 //    I/O for 506 eval project
 //
 // (C) Micrel Norway AS
 //     Proprietary firmware of Micrel Norway AS
 //
 


 // Note: The intention of the firmware listed below is to help users 
 //       get hands-on experience with Micrel Norway's products.
 
 //       No guarantee is implied as to the suitableness of the firmware 
 //       in a given application.
 
 //       For further information, please contact post@micrel.no


 #define IO_ADCON1INI  0b00001111 // All I/O digital I/O 



 #define IO_TRISAINI   0b110101
 #define IO_LATAINI    0b001000
 #define RF_RSSI       PORTAbits.RA0 // Analog input (if used)
 #define RA1_OUTP      LATAbits.LATA1 
 #define RA2_INP       PORTAbits.RA2 
 #define RS232_HS_OUT  LATAbits.LATA3
 #define RS232_HS_IN   PORTAbits.RA4
 #define RA5_NOTUSED   PORTAbits.RA5

 #define CTS_OUTPUT    RS232_HS_OUT 
 #define RTS_INPUT     RS232_HS_IN



 #define IO_TRISBINI  0b11101011
 #define IO_LATBINI   0b00000000
 #define RF_DATACLK   PORTBbits.RB0    //
 #define RF_LD        PORTBbits.RB1    //
 #define RF_LD_TRIS   TRISBbits.TRISB1 //
 #define RF_IO_IN     PORTBbits.RB2    //
 #define RF_IO_OUT    LATBbits.LATB2   //
 #define RF_IO_TRIS   TRISBbits.TRISB2 // 
 #define RF_DATA_IN   PORTBbits.RB3    //
 #define RF_DATA_OUT  LATBbits.LATB3   //
 #define RF_DATA_TRIS TRISBbits.TRISB3 //
 #define RF_CS        LATBbits.LATB4   //
 #define ICSP_PGM     PORTBbits.RB5    // Reserved ICSP
 #define ICSP_PGC     PORTBbits.RB6    // Reserved ICSP
 #define ICSP_PGD     PORTBbits.RB7    // Reserved ICSP



 #define IO_TRISCINI      0b10111011
 #define IO_LATCINI       0b01000000
 #define XTAL32_0         PORTCbits.RC0
 #define XTAL32_1         PORTCbits.RC1
 #define RF_SCLK          LATCbits.LATC2
 #define RF_DATA_SCL      PORTCbits.RC3
 #define RF_DATA_SDI      PORTCbits.RC4
 #define RF_DATA_SDO      LATCbits.LATC5 //Set as output when needed
 #define RF_DATA_SDO_TRIS TRISCbits.TRISC5
 #define RS232_DATA_OUT   LATCbits.LATC6
 #define RS232_DATA_IN    PORTCbits.RC7  

 #define TXD_INPUT      RS232_DATA_IN
 #define RXD_OUTPUT     RS232_DATA_OUT



 #define IO_TRISDINI  0b11110000
 #define IO_LATDINI   0b00001111   // Note: All LEDs ON initially
 #define LED1         LATDbits.LATD0
 #define LED2         LATDbits.LATD1
 #define LED3         LATDbits.LATD2
 #define LED4         LATDbits.LATD3
 #define DIP4         PORTDbits.RD4
 #define DIP3         PORTDbits.RD5
 #define DIP2         PORTDbits.RD6
 #define DIP1         PORTDbits.RD7



 #define IO_TRISEINI  0b111
 #define IO_LATEINI   0b000
 #define RE0_INP      PORTEbits.RE0
 #define RE1_INP      PORTEbits.RE1
 #define RE2_INP      PORTEbits.RE2
