
 #ifdef C_FILE

 //
 // RFPCK.H: Created 2003 01 14
 //    flags and constants, some variables are decleared
 //
 // (C) Micrel Norway AS
 //     Proprietary firmware of Micrel Norway AS
 //
 


 // Note: The intention of the firmware listed below is to help users 
 //       get hands-on experience with Micrel Norway's products.
 
 //       No guarantee is implied as to the suitableness of the firmware 
 //       in a given application.
 
 //       For further information, please contact post@micrel.no

 
 
//*************************************************
//
// Prototype declarations/Imported procedures
//
//*************************************************
#ifndef RFPCK_FILE
extern
#endif
void  RFPCK_Enable_RFTX_Interrupt( void);

#ifndef RFPCK_FILE
extern
#endif
void  RFPCK_Enable_RFRX_Interrupt( void);

#ifndef RFPCK_FILE
extern
#endif
void  RFPCK_Disable_RF_Interrupt( void);

#ifndef RFPCK_FILE
extern
#endif
void RFPCK_Tx_Int_Handler( void);

#ifndef RFPCK_FILE
extern
#endif
void RFPCK_Rx_Int_Handler( void);

#ifndef RFPCK_FILE
extern
#endif
void RFPCK_Init_Rx( void);

#ifndef RFPCK_FILE
extern
#endif
void RFPCK_Init_Tx( void);

#ifndef RFPCK_FILE
extern
#endif
void RFPCK_Fill_Code( void);

#ifndef RFPCK_FILE
extern
#endif
void RFPCK_Start_Tx_Packet( void);

#ifndef RFPCK_FILE
extern
#endif
void RFPCK_Start_Rx_Packet( void);

#ifndef RFPCK_FILE
extern
#endif
void  RFPCK_Init_Regs( void);

#ifndef RFPCK_FILE
extern
#endif
void  RFPCK_Update_Out_Nextin( void);

#ifndef RFPCK_FILE
extern
#endif
void  RFPCK_Update_In_Nextout( void);


#endif




 #define RFPCK_CLKELEM   0xAA //1010... tx "1" 1st 
 #define RFPCK_SYNCELEM  0xCC //1100... tx "1" 1st
 #define RFPCK_DUMMYELEM 0xFF


 #define RFPCK_BUFFERSIZE 70 // max langth of Payload level 1



 #ifdef C_FILE
 
//*************************************************
//
// Flags and variables
//
//*************************************************
 #ifdef RFPCK_FILE
    #pragma udata access rfpckh_udata_acs
 #else
    extern
 #endif
   volatile near union {
             struct {
                uint8 all;
             };
             struct {
                unsigned :1;
                unsigned :1;
                unsigned :1; //RX1010_TEST:1;
                unsigned EDGE_FOUND:1;
                unsigned SYNC_FOUND:1;                
                unsigned LENGTH_FOUND:1;
                unsigned PCK_FOUND:1;
                unsigned RX_STARTED:1;
             };
          } RFPCK_Rx_Flags;
        
        
          
 #ifndef RFPCK_FILE
    extern
 #endif
    volatile near union {
             struct {
               uint24 all;
             };
             struct {
                uint8 byte0;
                uint8 byte1;
                uint8 byte2;
             };
             struct {
                unsigned sample:1;
                unsigned :7;
                uint8 b1;
                uint8 b2;
             };
          } RFPCK_Rxregs; // Store received (via RF) bytes          



 #ifndef RFPCK_FILE
    extern
 #endif
    volatile near union {
             struct {
                uint8 all;
             };
             struct {
                unsigned TX_STARTED:1;
                unsigned DO_MANCHESTER:1;
                unsigned ELEMENT1_DONE:1;
                unsigned TX_FINISHED:1;
                unsigned :1; //TX_LAST_SYNC:1; // Set if started to tx last sync-elements 
                unsigned :1; //GOT_TIME:1;                
                unsigned :1; //TX1010_TEST:1;
                unsigned TXING:1;
             };
          } RFPCK_Tx_Flags;
          
          
/*
//TX_LAST_SYNC:
//when tx'ed a byte, if this bit is set, then sync is completely tx'ed
//If time-ino included, time is captured and included now
*/



#ifndef RFPCK_FILE
extern
#endif
volatile near union byte_and_bits  RFPCK_Txreg0,    // Bytes to tx (via RF)
                                   RFPCK_Txreg1;    //


#ifndef RFPCK_FILE
extern
#endif
volatile near uint8 RFPCK_Edge_Time, // Used in clock-recovery procedure
                    RFPCK_Remainder; // 


#ifndef RFPCK_FILE
extern
#endif
volatile near uint8 RFPCK_In_Length,     // Number of bytes received (via RF)
                    RFPCK_Out_Length,    // Number of bytes to transmit (via RF)
                    RFPCK_In_Nextin,     // Points to next location to store a rx'ed byte (in RF_in_Buffer)
                    RFPCK_In_Nextout,
                    RFPCK_Out_Nextout,   // Points to next location to transmit a byte from (in Rf_Out_Buffer)
                    RFPCK_Out_Nextin,                    
                    RFPCK_Rf_State,         // Used in state-machine
                    RFPCK_Temp_Pos,         // Temporary register
                    RFPCK_Temp,             // Temporary register
                    RFPCK_Temp_Length,      // Temporary register
                    RFPCK_First_Byte_Pos;   // Temporary register


#ifndef RFPCK_FILE
extern
#endif
volatile near union byte_and_bits RFPCK_Elmncntr; // Element-counter 



 #ifndef RFPCK_FILE
    extern
 #endif
    volatile near union {
             struct {
                uint8 all;
                    };
             struct {
                unsigned SET_PWR_BIT0:1;
                unsigned SET_PWR_BIT1:1;
                unsigned SET_PWR_BIT2:1;
                unsigned SET_BYP_LNA:1;
                unsigned PA_STATE_ON:1;
                unsigned ENTER_TX:1;
                unsigned ENTER_PD:1;
                unsigned DONE_FIRST_PWR_ON:1;
                    };
               } RFPCK_Status1;
               
 #ifndef RFPCK_FILE
    extern
 #endif
    volatile near union {
             struct {
                uint8 all;
                    };
             struct {
                unsigned USE_BITSYNC:1;
                unsigned RF_ACTIVE:1;
                unsigned :6;
                    };
               } RFPCK_Status2;               


#ifndef RFPCK_FILE
extern
#endif
 volatile near uint8 RFPCK_Code_Regs[ 16]; // Used when manchester-encoding a byte to transmit


               
#pragma udata
               
#ifndef RFPCK_FILE
extern
#endif
 volatile uint8 RFPCK_In_Buffer[  RFPCK_BUFFERSIZE],
                RFPCK_Out_Buffer[ RFPCK_BUFFERSIZE];
 
 #endif




 
 
 #ifdef ASM_FILE


 #ifdef RFPCK_FILE
RFPCK_ASM_UDATAACS UDATA_ACS
    
RFPCK_Status1   RES 1
RFPCK_Status2   RES 1    

 GLOBAL RFPCK_Status1
 GLOBAL RFPCK_Status2
 #else
  EXTERN RFPCK_Status1
  EXTERN RFPCK_Status2
 #endif
 
  #define SET_PWR_BIT0 RFPCK_Status1,0,0
  #define SET_PWR_BIT1 RFPCK_Status1,1,0
  #define SET_PWR_BIT2 RFPCK_Status1,2,0
  #define SET_BYP_LNA  RFPCK_Status1,3,0      
  #define PA_STATE_ON  RFPCK_Status1,4,0   
  #define ENTER_TX     RFPCK_Status1,5,0   
  #define ENTER_PD     RFPCK_Status1,6,0   
  #define DONE_FIRST_PWR_ON  RFPCK_Status1,7,0   

  #define USE_BITSYNC RFPCK_Status2,0,0
  #define RF_ACTIVE   RFPCK_Status2,1,0            

 #endif


